D			[0-9]
L			[a-zA-Z_]
H			[a-fA-F0-9]
R                       ["][^"]+["]

%{
#include <stdio.h>
#include "opttree.hpp"
#include "opts.tab.hpp"

//R                       [\](([^\])|([\][\]))+[\][ ]


extern char *bufferfunction;
extern int posbuffct;

void count();
//int input();

int column = 0;
int line_num = 0;



#define ECHO

#define YY_INPUT(buf,result,max_size) \
{ \
int i;\
for(i=0;i<max_size;){\
if(0==(buf[i]=bufferfunction[posbuffct])) break;\
i++;posbuffct++;}\
if(i==0) result=YY_NULL; else result=i;\
}

/*
"&&"			{ count(); return(AND_OP); }
"||"			{ count(); return(OR_OP); }
*/

/*
0[xX]{H}+{IS}?		{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;return(CONSTANT); }
0{D}+{IS}?		{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;return(CONSTANT); }
{D}+{IS}?		{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;yylval.expr->u.d=atoi(return(CONSTANT); }
L?'(\\.|[^\\'])+'	{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONF;return(CONSTANT); }

L?'(\\.|[^\\'])+'	{ count(); return(CONSTANT); }
{D}+{E}{FS}?		{ count(); return(CONSTANT); }

{D}*"."{D}+({E})?{FS}?	{ count(); return(CONSTANT); }
{D}+"."{D}*({E})?{FS}?	{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONF;yylval.expr->u.d=atof(yytext);return(CONSTANT); }

{ count(); return(STRING_LITERAL); }

*/

/*    int c = getchar(); 
    result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); */


%}

%x comment
%x comment2
%%
"/*"         BEGIN(comment);
"//"         BEGIN(comment2);
    
<comment>[^*\n]*        {}
<comment>"*"+[^*/\n]*   {}
<comment>\n             {line_num++;}
<comment>"*"+"/"        BEGIN(INITIAL);
<comment2>[^*\n]*        {}
<comment2>\n             BEGIN(INITIAL);

"else"			{ count(); return(ELSE); }
"if"			{ count(); return(IF); }

{L}({L}|{D}|\-)*		{ count(); yylval.name=strdup(yytext); return(FLAG);/*return(check_type());*/ }

{D}+		        { count(); yylval.name=yytext;return(FLAG); }

{R}                     { count(); yylval.name=strdup(yytext);printf("'%s'\n",yytext);return(REGEXP); }

"="			{ count(); return('='); }
"{"			{ count(); return('{'); }
"}"			{ count(); return('}'); }
"("			{ count(); return('('); }
")"			{ count(); return(')'); }
"!"			{ count(); return('!'); }
";"			{ count(); return(';'); }

[ \t\v\n\f]		{ count(); }
.			{ /* ignore bad characters */ }

%%

int yywrap()
{
	return(1);
}

void count()
{
	int i;

	for (i = 0; yytext[i] != '\0'; i++)
		if (yytext[i] == '\n')
			column = 0;
		else if (yytext[i] == '\t')
			column += 8 - (column % 8);
		else
			column++;

	ECHO;
}


int check_type()
{
/*
* pseudo code --- this is what it should check
*
*	if (yytext == type_name)
*		return(TYPE_NAME);
*/
	return(FLAG);
}
